/* vi: set sw=4 ts=4: */
/*
 *	xstream.h
 *
 *	extensible stream module.
 *
 *	Created by David Hsieh <david_hsieh@alphanetworks.com>
 */

#ifndef __XSTREAM_HEADER_FILE__
#define __XSTREAM_HEADER_FILE__

typedef enum { XSTYPE_UNKNOWN=0, XSTYPE_FILE, XSTYPE_SOCKET, XSTYPE_BUFFER } xstype_t;
typedef void * xstream_t;

xstream_t xs_fopen(const char * file, const char * mode);
xstream_t xs_sopen(int domain, int type, int protocol);
xstream_t xs_bopen(void * buff, size_t size);
int xs_close(xstream_t fd);
int xs_getc(xstream_t fd);
int xs_ungetc(int c, xstream_t fd);
int xs_ungets(const char * s, xstream_t fd);

#endif
