/*
 * Carsten Langgaard, carstenl@mips.com
 * Copyright (C) 1999,2000 MIPS Technologies, Inc.  All rights reserved.
 *
 * This program is free software; you can distribute it and/or modify it
 * under the terms of the GNU General Public License (Version 2) as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
 *
 * Kernel command line creation using the prom monitor (YAMON) argc/argv.
 */
#include <linux/init.h>
#include <linux/string.h>

#include <asm/bootinfo.h>

/* modified by Leo, 2007/08/07 10:24:40 */
#if 1
	#include <linux/config.h>
	char rt2880_cmdline[] = CONFIG_CMDLINE;
#else
	#if defined (CONFIG_RT2880_ROOTFS_IN_FLASH)
		char rt2880_cmdline[]="console=ttyS1,57600n8 root=/dev/mtdblock4";
	#elif defined (CONFIG_RT2880_ROOTFS_IN_RAM)
		char rt2880_cmdline[]="console=ttyS1,57600n8 root=/dev/ram0";
	#else
		#error "RT2880 Root File System not defined"
	#endif
#endif
/* ********************************* */

extern int prom_argc;
extern int *_prom_argv;

/*
 * YAMON (32-bit PROM) pass arguments and environment as 32-bit pointer.
 * This macro take care of sign extension.
 */
#define prom_argv(index) ((char *)(((int *)(int)_prom_argv)[(index)]))

char arcs_cmdline[CL_SIZE];

char * __init prom_getcmdline(void)
{
	return &(arcs_cmdline[0]);
}

void  __init prom_init_cmdline(void)
{
	char *cp;
	int actr=1; /* Always ignore argv[0] */

	cp = &(arcs_cmdline[0]);

#if defined CONFIG_CMD_BOOL
	strcpy(cp, CONFIG_CMDLINE);
	cp += strlen(CONFIG_CMDLINE);
	*cp++ = ' ';
#else
	strcpy(cp, rt2880_cmdline);
	cp += strlen(rt2880_cmdline);
	*cp++ = ' ';
#endif

	while(actr < prom_argc) {
	    strcpy(cp, prom_argv(actr));
	    cp += strlen(prom_argv(actr));
	    *cp++ = ' ';
	    actr++;
	}
	if (cp != &(arcs_cmdline[0])) /* get rid of trailing space */
	    --cp;
	*cp = '\0';

}
