#ifndef _IP_CONNTRACK_H323_H
#define _IP_CONNTRACK_H323_H
/* H.323 connection tracking. */
#include <linux/netfilter_ipv4/ip_conntrack_tuple.h>
//#ifdef __KERNEL__

/* Default H.225 port */
#define H225_PORT	1720
/* This structure is per expected connection */
struct ip_ct_h225_expect {
	u_int16_t port;			/* Port of the H.225 helper/RTCP/RTP channel */
	enum ip_conntrack_dir dir;	/* Direction of the original connection */
	unsigned int offset;		/* offset of the address in the payload */
};

/* This structure exists only once per master */
struct ip_ct_h225_master {
	int is_h225;				/* H.225 or H.245 connection */
#ifdef CONFIG_IP_NF_NAT_NEEDED
	enum ip_conntrack_dir dir;		/* Direction of the original connection */
	u_int32_t seq[IP_CT_DIR_MAX];		/* Exceptional packet mangling for signal addressess... */
	unsigned int offset[IP_CT_DIR_MAX];	/* ...and the offset of the addresses in the payload */
//#endif
};

struct ip_conntrack_expect;
struct ip_conntrack;
struct ip_conntrack_helper;
extern struct ip_conntrack_helper ip_conntrack_helper_h225;

extern int (*ip_nat_h245_hook)(struct sk_buff **pskb,
			       enum ip_conntrack_info ctinfo,
			       unsigned int offset,
			       struct ip_conntrack_expect *exp);

extern int (*ip_nat_h225_hook)(struct sk_buff **pskb,
			       enum ip_conntrack_info ctinfo,
			       unsigned int offset,
			       struct ip_conntrack_expect *exp);

extern void (*ip_nat_h225_signal_hook)(struct sk_buff **pskb,
				       struct ip_conntrack *ct,
				       enum ip_conntrack_info ctinfo,
				       unsigned int offset,
				       int dir,
				       int orig_dir);


void ip_conntrack_h245_expect(struct ip_conntrack *new,
			      struct ip_conntrack_expect *this);

#endif /* __KERNEL__ */

#endif /* _IP_CONNTRACK_H323_H */
