#include "wlxmlpatch.h"

#define MAX_LEN_OF_MAC_TABLE            32 //max 250 stations, 1 for bc/mc, can not >= 256

#if MAX_LEN_OF_MAC_TABLE>=256
#error MAX_LEN_OF_MAC_TABLE can not be larger than 255!!!!
#endif

#ifndef SIOCDEVPRIVATE
#define SIOCDEVPRIVATE                      0x8BE0
#define SIOCIWFIRSTPRIV                     SIOCDEVPRIVATE
#endif
#define RTPRIV_IOCTL_GET_MAC_TABLE          (SIOCIWFIRSTPRIV + 0x0F)

#ifdef ELBOX_PROGS_PRIV_RT2860V2_STA
#define	OID_GEN_MEDIA_CONNECT_STATUS        0x060B
#define RT_PRIV_IOCTL                       (SIOCIWFIRSTPRIV + 0x0e)
typedef unsigned int                        NDIS_MEDIA_STATE;
#endif /*ELBOX_PROGS_PRIV_RT2860V2_STA*/

static char * B_MCS[]           ={  "1",        "2",        "5.5",      "11",       "N/A",\
                                    "N/A",      "N/A",      "N/A",      "1",        "2",\
                                    "5.5",      "11",       NULL};
static char * G_MCS[]           ={  "6",        "9",        "12",       "18",       "24",\
                                    "36",       "48",       "54",       NULL};
static char * N_SGI_20_MCS[]    ={  "7.2",      "14.4",     "21.7",     "28.9",     "43.3",\
                                    "57.8",     "65.0",     "72.2",     "14.444",   "28.889",\
                                    "43.333",   "57.778",   "86.667",   "115.556",  "130.000",\
                                    "144.444",  NULL};
static char * N_LGI_20_MCS[]    ={  "6.5",      "13.0",     "19.5",     "26.0",     "39.0",\
                                    "52",       "58.5",     "65",       "13.0",     "26.0",\
                                    "39.0",     "52.0",     "78.0",     "104.0",    "117.0",\
                                    "130.0",    NULL};
static char * N_SGI_40_MCS[]    ={  "15.0",     "30.0",     "45.0",     "60.0",     "90.0",\
                                    "120.0",    "135.0",    "150.0",    "30.0",     "60.0",\
                                    "90.0",     "120.0",    "180.0",    "240.0",    "270.0",\
                                    "300.0",    NULL};
static char * N_LGI_40_MCS[]    ={  "13.5",     "27.0",     "40.5",     "54.0",     "81.0",\
                                    "108",      "121.5",    "135.0",    "27.0",     "54.0",\
                                    "81.0",     "108.0",    "162.0",    "216.0",    "243.0",\
                                    "270.0",    NULL};

#define MAC_ADDR_LEN    6
#define CHAR            signed char
#define INT             signed int
#define SHORT           signed short
#define UINT            unsigned int
#undef  ULONG
#define ULONG           unsigned int
#define USHORT          unsigned short
#define UCHAR           unsigned char

#if 0
typedef union  _MACHTTRANSMIT_SETTING
{
    struct
    {
        USHORT      MCS:7;  // MCS
        USHORT      BW:1;   //channel bandwidth 20MHz or 40 MHz
        USHORT      ShortGI:1;
        USHORT      STBC:2; //SPACE
        USHORT      rsv:3;
        USHORT      MODE:2; // Use definition MODE_xxx.
    }   field;
    USHORT      word;
} MACHTTRANSMIT_SETTING, *PMACHTTRANSMIT_SETTING;

typedef struct _RT_802_11_MAC_ENTRY
{
    UCHAR       Addr[MAC_ADDR_LEN];
    UCHAR       Aid;
    UCHAR       Psm;     // 0:PWR_ACTIVE, 1:PWR_SAVE
    UCHAR       MimoPs;  // 0:MMPS_STATIC, 1:MMPS_DYNAMIC, 3:MMPS_NO_LIMIT
    MACHTTRANSMIT_SETTING   TxRate;
    UCHAR       apidx;
} RT_802_11_MAC_ENTRY, *PRT_802_11_MAC_ENTRY;

typedef struct _RT_802_11_MAC_TABLE
{
    ULONG       Num;
    RT_802_11_MAC_ENTRY Entry[MAX_LEN_OF_MAC_TABLE];
} RT_802_11_MAC_TABLE, *PRT_802_11_MAC_TABLE;

#endif

typedef union  _MACHTTRANSMIT_SETTING {
    struct  {
    USHORT      MCS:7;                 // MCS
    USHORT      BW:1;   //channel bandwidth 20MHz or 40 MHz
    USHORT      ShortGI:1;
    USHORT      STBC:2; //SPACE
    USHORT      rsv:3;
    USHORT      MODE:2; // Use definition MODE_xxx.
    }   field;
    USHORT      word;
 } MACHTTRANSMIT_SETTING, *PMACHTTRANSMIT_SETTING;

typedef struct _RT_802_11_MAC_ENTRY {
    UCHAR       Addr[MAC_ADDR_LEN];
    UCHAR       Aid;
    UCHAR       Psm;     // 0:PWR_ACTIVE, 1:PWR_SAVE
    UCHAR       MimoPs;  // 0:MMPS_STATIC, 1:MMPS_DYNAMIC, 3:MMPS_Enabled
    MACHTTRANSMIT_SETTING   TxRate;
    CHAR        rssi;/*Client_signal_strength_10071109*//*Added by Erick*/    
} RT_802_11_MAC_ENTRY, *PRT_802_11_MAC_ENTRY;

typedef struct _RT_802_11_MAC_TABLE {
    ULONG       Num;
    RT_802_11_MAC_ENTRY Entry[MAX_LEN_OF_MAC_TABLE];
} RT_802_11_MAC_TABLE, *PRT_802_11_MAC_TABLE;

