#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <signal.h>
#include <sys/sysinfo.h>

#include <dtrace.h>
#include <dlist.h>
#include <libxmldbc.h>
#include <iwlib.h>

#include <elbox_config.h>

#define MAXLEN          64

struct client_info
{
    struct dlist_head   link;
    long                uptime;         /* uptime time stamp of connection */
    u_int8_t            mac_addr[6];    /* mac address */
    int                 mode;           /* connection mode (11b, 11g, 11n) */
    int                 bw;             /* bandwidth (20MHz, 40MHz) */
    int                 sgi;            /* short guard interval */
    int                 mcs;            /* mcs index */
    int                 inf;
    int                 hit;
    int                 signal_strength;/*Client_signal_strength_10071109*//*Added by Erick*/
#ifdef ELBOX_PROGS_PRIV_WLXMLPATCHV2_MADWIFI
	int                 rate;           /* connection rates */
	int                 rssi;           /* received signal strength indicator */
	int             	ssid_index;    /* STAMODE dennis */
	int					psmode; /* STAMODE power saving mode dennis */
#endif
};

/* function prototype */
long _uptime(void);
int add_client(struct dlist_head * , const struct client_info * );

/* function pointer prototype */
/*-----------------------------------------*/
#ifdef ELBOX_PROGS_PRIV_RT2860V2_STA
unsigned int rt2800_ioctl_get_bridge_status(int, char*);
#endif /*ELBOX_PROGS_PRIV_RT2860V2_STA*/
int rt2800_ioctl_get_channel(int , char*);
int rt2800_set_extention_channel(int);
int rt61_ioctl_get_channel(int , char*);
int madwifi_ioctl_get_channel(int , char*);
int def_ioctl_get_channel(int , char*);
/*-----------------------------------------*/
void rt2800_ioctl_get_clients_list(int, const char *, struct dlist_head *);
void rt61_ioctl_get_clients_list(int, const char *, struct dlist_head *);
void madwifi_ioctl_get_clients_list(int, const char *, struct dlist_head *);
void def_ioctl_get_clients_list(int, const char *, struct dlist_head *);
/*-----------------------------------------*/
void rt2800_set_mode_rate_phase1(char *, char *, struct client_info *);
void rt61_set_mode_rate_phase1(char *, char *, struct client_info *);
void madwifi_set_mode_rate_phase1(char *, char *, struct client_info *);
void def_set_mode_rate_phase1(char *, char *, struct client_info *);
/*-----------------------------------------*/


