# wan_ip_setup >>>
<? /* vi: set sw=4 ts=4: */
$dhcpc_ppp_pid = "/var/run/udhcpc-ppp.pid";
$wanif = query("/runtime/layout/wanif");
$wanmode = query("/wan/rg/inf:1/mode");
if		($wanmode == "4")	{ anchor("/wan/rg/inf:1/pptp"); $PPPMODE="PPTP"; }
else if	($wanmode == "5")	{ anchor("/wan/rg/inf:1/l2tp"); $PPPMODE="L2TP"; }
else
{
	echo "echo \"Not in PPTP/L2TP mode ...\" > /dev/console\n";
	exit;
}

/* read configuration */
$dhcp_mode	= query("mode");
$ipaddr		= query("ip");
$subnet		= query("netmask");
$gateway	= query("gateway");
$dns		= query("dns");
$serverip	= query("serverip");
$physical	= query("physical");

if ($generate_start == 1)
{
	if ($PPPMODE == "PPTP")
	{
		set("/runtime/wan/inf:1/connecttype", "4"); 

		$orig_wanmac= query("/runtime/layout/wanmac");
		$curr_wanmac= query("/runtime/wan/inf:1/mac");
		$clonemac   = query("/wan/rg/inf:1/pptp/clonemac");
		require($template_root."/clone_wanmac.php");
	}
	else
	{
		set("/runtime/wan/inf:1/connecttype", "5"); 

		$orig_wanmac= query("/runtime/layout/wanmac");
		$curr_wanmac= query("/runtime/wan/inf:1/mac");
		$clonemac   = query("/wan/rg/inf:1/l2tp/clonemac");
		require($template_root."/clone_wanmac.php");
	}
	set("/runtime/wan/inf:1/ip", "");
	set("/runtime/wan/inf:1/netmask", "");
	set("/runtime/wan/inf:1/gateway", "");
	set("/runtime/wan/inf:1/primarydns", "");
	set("/runtime/wan/inf:1/secondarydns", "");
	set("/runtime/wan/inf:1/mtu", "");

	set("/runtime/wan/phy/ip", "");
	set("/runtime/wan/phy/netmask", "");

	if ($dhcp_mode == 2)
	{
		echo "echo \"Setup DHCP for ".$PPPMODE." ...\" > /dev/console\n";
		echo "rgdb -A ".$template_root."/dhcp/dhcpc_ppp.php";
		echo	" -V physical=".$physical." -V server=".$serverip." > /var/run/dhcpc_ppp.sh\n";
		echo "chmod +x /var/run/dhcpc_ppp.sh\n";
		echo "udhcpc -i ".$wanif." -p ".$dhcpc_ppp_pid." -H ".query("/sys/modelname");
		echo " -s /var/run/dhcpc_ppp.sh -D2 -R5 -S300 &\n";
	}
	else
	{
		echo "echo \"Setup Static IP for ".$PPPMODE." ...\" > /dev/console\n";
		echo "ifconfig ".$wanif." ".$ipaddr;
		if ($subnet != "" && $subnet != "0.0.0.0") { echo " netmask ".$subnet; }
		echo "\n";
		if ($dns != "" && $dns != "0.0.0.0")
		{
			echo "echo \"nameserver ".$dns."\" > /etc/resolv.conf\n";
			echo "if [ \"`chnet ".$dns." ".$subnet."`\" != \"`chnet ".$ipaddr." ".$subnet."`\" ]; then\n";
			echo "	route add -host ".$dns." gw ".$gateway." dev ".$wanif."\n";
			echo "fi\n";
		}
		echo "SERVER=`gethostip -d ".$serverip."`\n";
		echo "if [ \"$SERVER\" != \"\" ]; then\n";
		echo "	if [ \"`chnet $SERVER ".$subnet."`\" != \"`chnet ".$ipaddr." ".$subnet."`\" ]; then\n";
		echo "		route add -host $SERVER gw ".$gateway." dev ".$wanif."\n";
		echo "	fi\n";
		echo "	sh ".$template_root."/wan_ppp.sh start $SERVER > /dev/console\n";
		echo "else\n";
		echo "	echo \"Can not find server (".$serverip.") : $SERVER\" > /dev/console\n";
		echo "fi\n";

		set("/runtime/wan/phy/ip",		$ipaddr);
		set("/runtime/wan/phy/netmask",	$subnet);
		if ($physical==1)
		{
			set("/runtime/wan/inf:2/connecttype", "1");
			anchor("/runtime/wan/inf:2");
			set("connectstatus", "connected");
			set("ip", $ipaddr);
			set("netmask", $subnet);
			set("gateway", $gateway);
			set("primarydns", $dns);
			set("interface", $wanif);
		}
	}
}
else
{
	echo $template_root."/wan_ppp.sh stop > /dev/console\n";
	if ($dhcp_mode == 2)
	{
		echo "echo \"Stop DHCP of ".$PPPMODE." ...\" > /dev/console\n";
		echo "if [ -f ".$dhcpc_ppp_pid." ]; then\n";
		echo "	PID=`cat ".$dhcpc_ppp_pid."`\n";
		echo "	if [ $PID != 0 ]; then\n";
		echo "		kill -SIGUSR2 $PID > /dev/console 2>&1\n";
		echo "		kill $PID > /dev/console 2>&1\n";
		echo "	fi\n";
		echo "	rm -f ".$dhcpc_ppp_pid."\n";
		echo "fi\n";
	}
	else
	{
		echo "echo \"Stop Static IP of ".$PPPMODE." ...\" > /dev/console\n";
		echo "rgdb -i -s /runtime/wan/inf:2/connectstatus disconnected\n";
		echo "rgdb -i -s /runtime/wan/inf:2/ip \"\"\n";
		echo "rgdb -i -s /runtime/wan/inf:2/netmask \"\"\n";
		echo "rgdb -i -s /runtime/wan/inf:2/gateway \"\"\n";
		echo "rgdb -i -s /runtime/wan/inf:2/primarydns \"\"\n";
		echo "rgdb -i -s /runtime/wan/inf:2/secondarydns \"\"\n";
		echo "rgdb -i -s /runtime/wan/inf:2/interface \"\"\n";
		echo "rgdb -i -s /runtime/wan/inf:2/mtu \"\"\n";
	}
	echo "ifconfig ".$wanif." 0.0.0.0 > /dev/console 2>&1\n";
}
?>#wan_ip_setup <<<
